// WinAmp.cpp : Implementation of CWinAmp

#include "stdafx.h"
#include "WinAmp.h"
#include "Global.h"
#include "frontend.h"

// TO DO: Race condition mentioned below (search for "TO DO").
// TO DO: A couple of functions from FrontEnd.h are not supported at the moment.
// TO DO: Maybe add functions which atomically get the current track file/title.
// TO DO: Maybe add function which atomically gets array of entire playlist.

// CWinAmp

HRESULT CWinAmp::simpleSendMessage(LRESULT *pSmRes, UINT msg, WPARAM wp, LPARAM lp)
{
	HRESULT res = E_FAIL;

	HWND hwndPlugin = FindWindow(szwaGenScriptingWindowClass, NULL);

	if (NULL != hwndPlugin)
	{
		LRESULT smRes = SendMessage(hwndPlugin, msg, wp, lp);

		if (NULL != pSmRes)
		{
			*pSmRes = smRes;
		}

		res = S_OK;
	}

	return(res);
}

HRESULT CWinAmp::sendMessageAndGetStringReply(BSTR *pSmRes, UINT msg, WPARAM wp)
{
	HRESULT res = E_FAIL;

	WNDCLASSEX wcex;
	ZeroMemory(&wcex, sizeof(wcex));
	wcex.cbSize			= sizeof(wcex);
	wcex.style			= 0;
	wcex.lpfnWndProc	= reinterpret_cast<WNDPROC>(CWinAmp::replyWndProc);
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= _AtlBaseModule.GetModuleInstance();
	wcex.hIcon			= NULL;
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szwagsReplyWindowClass;
	wcex.hIconSm		= NULL;

	CWinAmp::ReplyWindowData rwd;
	rwd.bRunMsgLoop = true;

	if (0 != RegisterClassEx(&wcex) || ERROR_CLASS_ALREADY_EXISTS == GetLastError())
	{
		HWND hwndForReply = CreateWindow(szwagsReplyWindowClass,
											szwagsReplyWindowClass,
											WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
											0, 100, 100, NULL, NULL,
											_AtlBaseModule.GetModuleInstance(), NULL);

		if (NULL != hwndForReply)
		{
			SetWindowLongPtr(hwndForReply, GWLP_USERDATA, reinterpret_cast<LONG_PTR>(&rwd));

			LRESULT ssmRes = 0;

			if (S_OK == simpleSendMessage(&ssmRes, msg, wp, reinterpret_cast<LPARAM>(hwndForReply))
			&&	0 != ssmRes)
			{
				MSG msg;
				BOOL bgmRet;

				while (rwd.bRunMsgLoop && (bgmRet = GetMessage(&msg, hwndForReply, 0, 0)))
				{
					if (-1 == bgmRet)
					{
						break; // GetMessage Error
					}
					else
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}

				if (!rwd.bRunMsgLoop)
				{
					(*pSmRes) = SysAllocString(LeoDavidsonUtils::LeetMBtoWCString(rwd.str.c_str()).c_str());
					res = S_OK;
				}
			}

			DestroyWindow(hwndForReply);
		}
	}

	return(res);
}

LRESULT CALLBACK CWinAmp::replyWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
	case(WM_COPYDATA):
		{
			COPYDATASTRUCT *pCds = reinterpret_cast<COPYDATASTRUCT *>(lParam);
			CWinAmp::ReplyWindowData *pRwd = reinterpret_cast<CWinAmp::ReplyWindowData *>(GetWindowLongPtr(hWnd, GWLP_USERDATA));

			if (NULL != pRwd)
			{
				pRwd->bRunMsgLoop = false;

				if (NULL != pCds)
				{
					pRwd->str = reinterpret_cast<char *>(pCds->lpData);
				}
			}

			PostMessage(hWnd, WM_APP, 0, 0); // wake up the msg loop

			return(0);
		}
		break;
	case(WM_APP):
		return(0);
		break;
	default:
		return(DefWindowProc(hWnd, message, wParam, lParam));
	}

	return 0;
}

STDMETHODIMP CWinAmp::ToggleEq(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_OPTIONS_EQ, 0));
}

STDMETHODIMP CWinAmp::TogglePlaylist(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_OPTIONS_PLEDIT, 0));
}

STDMETHODIMP CWinAmp::VolumeUp(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_VOLUMEUP, 0));
}

STDMETHODIMP CWinAmp::VolumeDown(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_VOLUMEDOWN, 0));
}

STDMETHODIMP CWinAmp::ForwardFiveSeconds(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_FFWD5S, 0));
}

STDMETHODIMP CWinAmp::RewindFiveSeconds(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_REW5S, 0));
}

STDMETHODIMP CWinAmp::ButtonPreviousTrack(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON1, 0));
}

STDMETHODIMP CWinAmp::ButtonPlay(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON2, 0));
}

STDMETHODIMP CWinAmp::ButtonPause(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON3, 0));
}

STDMETHODIMP CWinAmp::ButtonStop(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON4, 0));
}

STDMETHODIMP CWinAmp::ButtonNextTrack(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON5, 0));
}

STDMETHODIMP CWinAmp::ButtonOpenAndPlay(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON2_SHIFT, 0));
}

STDMETHODIMP CWinAmp::ButtonFadeOutAndStop(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON4_SHIFT, 0));
}

STDMETHODIMP CWinAmp::ButtonPreviousFileInPlaylist(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON1_CTRL, 0));
}

STDMETHODIMP CWinAmp::ButtonOpenLocation(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON2_CTRL, 0));
}

STDMETHODIMP CWinAmp::ButtonNextFileInPlaylist(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_BUTTON5_CTRL, 0));
}

STDMETHODIMP CWinAmp::ShowOpenFileDialog(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_FILE_PLAY, 0));
}

STDMETHODIMP CWinAmp::ShowPreferences(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_OPTIONS_PREFS, 0));
}

STDMETHODIMP CWinAmp::ToggleAlwaysOnTop(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_OPTIONS_AOT, 0));
}

STDMETHODIMP CWinAmp::ShowAbout(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_COMMAND, WINAMP_HELP_ABOUT, 0));
}

STDMETHODIMP CWinAmp::ClearPlaylist(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_USER, 0, IPC_DELETE));
}

STDMETHODIMP CWinAmp::StartPlay(void)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_USER, 0, IPC_STARTPLAY));
}

STDMETHODIMP CWinAmp::GetVersion(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_GETVERSION));
}

STDMETHODIMP CWinAmp::IsPlaying(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_ISPLAYING));
}

STDMETHODIMP CWinAmp::WritePlaylist(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_WRITEPLAYLIST));
}

STDMETHODIMP CWinAmp::GetPlaylistLength(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_GETLISTLENGTH));
}

STDMETHODIMP CWinAmp::GetPlaylistPosition(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_GETLISTPOS));
}

STDMETHODIMP CWinAmp::GetTrackPositionMilliseconds(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_GETOUTPUTTIME));
}

STDMETHODIMP CWinAmp::GetTrackLengthSeconds(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 1, IPC_GETOUTPUTTIME));
}

STDMETHODIMP CWinAmp::SetTrackPositionMilliseconds(LONG arg, LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, arg, IPC_JUMPTOTIME));
}

STDMETHODIMP CWinAmp::GetTrackSampleRate(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 0, IPC_GETINFO));
}

STDMETHODIMP CWinAmp::GetTrackBitRate(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 1, IPC_GETINFO));
}

STDMETHODIMP CWinAmp::GetTrackChannels(LONG* res)
{
	return(CWinAmp::simpleSendMessage(res, WM_USER, 2, IPC_GETINFO));
}

STDMETHODIMP CWinAmp::SetPlaylistPosition(LONG arg)
{
	return(CWinAmp::simpleSendMessage(NULL, WM_USER, arg, IPC_SETPLAYLISTPOS));
}

STDMETHODIMP CWinAmp::SetVolume(LONG arg)
{
	if (  0 > arg) arg = 0;
	if (255 < arg) arg = 255;

	return(CWinAmp::simpleSendMessage(NULL, WM_USER, arg, IPC_SETVOLUME));
}

STDMETHODIMP CWinAmp::SetPanning(LONG arg)
{
	if (-128 > arg) arg = -128;
	if ( 128 < arg) arg =  128;

	return(CWinAmp::simpleSendMessage(NULL, WM_USER, arg, IPC_SETPANNING));
}

STDMETHODIMP CWinAmp::GetEqData(LONG arg, LONG* res)
{
	if (0 > arg || 12 < arg)
	{
		return(E_FAIL);
	}

	return(CWinAmp::simpleSendMessage(res, WM_USER, arg, IPC_GETEQDATA));
}

STDMETHODIMP CWinAmp::SetEqData(LONG arg, LONG val)
{
	if (0 > arg || 12 < arg)
	{
		return(E_FAIL);
	}

	if (11 != arg && 12 != arg)
	{
		if ( 0 > val) val = 0;
		if (63 < val) val = 63;
	}

	// TO DO: Note that there is a race condition since something else may get
	// another EQ setting between our two calls. Strictly, this should be made
	// an atomic call to the plug-in side but it's not really worth it in reality.

	HRESULT res = CWinAmp::simpleSendMessage(NULL, WM_USER, arg, IPC_GETEQDATA);

	if (S_OK == res)
	{
		res = CWinAmp::simpleSendMessage(NULL, WM_USER, val, IPC_SETEQDATA);
	}

	return res;
}

STDMETHODIMP CWinAmp::PlayFile(BSTR arg)
{
	std::string strArgAnsi = LeoDavidsonUtils::LeetWCtoMBString(arg);

	COPYDATASTRUCT cds;
	ZeroMemory(&cds, sizeof(cds));
	cds.dwData = IPC_PLAYFILE;
	cds.lpData = const_cast<void *>(reinterpret_cast<const void *>(strArgAnsi.c_str()));
	cds.cbData = strArgAnsi.length() + 1;

	return(CWinAmp::simpleSendMessage(NULL, WM_COPYDATA, 0, reinterpret_cast<LPARAM>(&cds)));
}

STDMETHODIMP CWinAmp::ChangeDirectory(BSTR arg)
{
	std::string strArgAnsi = LeoDavidsonUtils::LeetWCtoMBString(arg);

	COPYDATASTRUCT cds;
	ZeroMemory(&cds, sizeof(cds));
	cds.dwData = IPC_CHDIR;
	cds.lpData = const_cast<void *>(reinterpret_cast<const void *>(strArgAnsi.c_str()));
	cds.cbData = strArgAnsi.length() + 1;

	return(CWinAmp::simpleSendMessage(NULL, WM_COPYDATA, 0, reinterpret_cast<LPARAM>(&cds)));
}

STDMETHODIMP CWinAmp::GetPlaylistFile(LONG arg, BSTR* res)
{
	return(CWinAmp::sendMessageAndGetStringReply(res, WM_USER+1, arg));
}

STDMETHODIMP CWinAmp::GetPlaylistTitle(LONG arg, BSTR* res)
{
	return(CWinAmp::sendMessageAndGetStringReply(res, WM_USER+2, arg));
}
