// WinAmp.h : Declaration of the CWinAmp

#pragma once
#include "resource.h"       // main symbols


// IWinAmp
[
	object,
	uuid("F307D616-577B-49CD-8A93-85F7DF6F93C0"),
	dual,	helpstring("IWinAmp Interface"),
	pointer_default(unique)
]
__interface IWinAmp : IDispatch
{
	[id(1), helpstring("method ToggleEq")] HRESULT ToggleEq(void);
	[id(2), helpstring("method TogglePlaylist")] HRESULT TogglePlaylist(void);
	[id(3), helpstring("method VolumeUp")] HRESULT VolumeUp(void);
	[id(4), helpstring("method VolumeDown")] HRESULT VolumeDown(void);
	[id(5), helpstring("method ForwardFiveSeconds")] HRESULT ForwardFiveSeconds(void);
	[id(6), helpstring("method RewindFiveSeconds")] HRESULT RewindFiveSeconds(void);
	[id(7), helpstring("method ButtonPreviousTrack")] HRESULT ButtonPreviousTrack(void);
	[id(8), helpstring("method ButtonPlay")] HRESULT ButtonPlay(void);
	[id(9), helpstring("method ButtonPause")] HRESULT ButtonPause(void);
	[id(10), helpstring("method ButtonStop")] HRESULT ButtonStop(void);
	[id(11), helpstring("method ButtonNextTrack")] HRESULT ButtonNextTrack(void);
	[id(12), helpstring("method ButtonOpenAndPlay")] HRESULT ButtonOpenAndPlay(void);
	[id(13), helpstring("method ButtonFadeOutAndStop")] HRESULT ButtonFadeOutAndStop(void);
	[id(14), helpstring("method ButtonPreviousFileInPlaylist")] HRESULT ButtonPreviousFileInPlaylist(void);
	[id(15), helpstring("method ButtonOpenLocation")] HRESULT ButtonOpenLocation(void);
	[id(16), helpstring("method ButtonNextFileInPlaylist")] HRESULT ButtonNextFileInPlaylist(void);
	[id(17), helpstring("method ShowOpenFileDialog")] HRESULT ShowOpenFileDialog(void);
	[id(18), helpstring("method ShowPreferences")] HRESULT ShowPreferences(void);
	[id(19), helpstring("method ToggleAlwaysOnTop")] HRESULT ToggleAlwaysOnTop(void);
	[id(20), helpstring("method ShowAbout")] HRESULT ShowAbout(void);
	[id(21), helpstring("method ClearPlaylist")] HRESULT ClearPlaylist(void);
	[id(22), helpstring("method StartPlay")] HRESULT StartPlay(void);
	[id(23), helpstring("method GetVersion")] HRESULT GetVersion([out,retval] LONG* res);
	[id(24), helpstring("method IsPlaying")] HRESULT IsPlaying([out,retval] LONG* res);
	[id(25), helpstring("method WritePlaylist")] HRESULT WritePlaylist([out,retval] LONG* res);
	[id(26), helpstring("method GetPlaylistLength")] HRESULT GetPlaylistLength([out,retval] LONG* res);
	[id(27), helpstring("method GetPlaylistPosition")] HRESULT GetPlaylistPosition([out,retval] LONG* res);
	[id(28), helpstring("method GetSongPositionMilliseconds")] HRESULT GetTrackPositionMilliseconds([out,retval] LONG* res);
	[id(29), helpstring("method GetTrackLengthSeconds")] HRESULT GetTrackLengthSeconds([out,retval] LONG* res);
	[id(30), helpstring("method SetTrackPositionMilliseconds")] HRESULT SetTrackPositionMilliseconds([in] LONG arg, [out,retval] LONG* res);
	[id(31), helpstring("method GetTrackSampleRate")] HRESULT GetTrackSampleRate([out,retval] LONG* res);
	[id(32), helpstring("method GetTrackBitRate")] HRESULT GetTrackBitRate([out,retval] LONG* res);
	[id(33), helpstring("method GetTrackChannels")] HRESULT GetTrackChannels([out,retval] LONG* res);
	[id(34), helpstring("method SetPlaylistPosition")] HRESULT SetPlaylistPosition([in] LONG arg);
	[id(35), helpstring("method SetVolume")] HRESULT SetVolume([in] LONG arg);
	[id(36), helpstring("method SetPanning")] HRESULT SetPanning([in] LONG arg);
	[id(37), helpstring("method GetEqBand")] HRESULT GetEqData([in] LONG arg, [out,retval] LONG* res);
	[id(38), helpstring("method SetEqData")] HRESULT SetEqData([in] LONG arg, [in] LONG val);
	[id(39), helpstring("method PlayFile")] HRESULT PlayFile([in] BSTR arg);
	[id(40), helpstring("method ChangeDirectory")] HRESULT ChangeDirectory([in] BSTR arg);
	[id(41), helpstring("method GetPlaylistFile")] HRESULT GetPlaylistFile([in] LONG arg, [out,retval] BSTR* res);
	[id(42), helpstring("method GetPlaylistTitle")] HRESULT GetPlaylistTitle([in] LONG arg, [out,retval] BSTR* res);
};



// CWinAmp

[
	coclass,
	threading("free"),
	vi_progid("gen_scripting.WinAmp"),
	progid("gen_scripting.WinAmp.1"),
	version(1.0),
	uuid("E3336D80-C881-4D8A-B9AF-2AF23D215F3A"),
	helpstring("WinAmp Class")
]
class ATL_NO_VTABLE CWinAmp : 
	public IWinAmp
{
public:
	CWinAmp()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

protected:
	static LRESULT CALLBACK replyWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

	static HRESULT simpleSendMessage(LRESULT *pSmRes, UINT msg, WPARAM wp, LPARAM lp);
	static HRESULT sendMessageAndGetStringReply(BSTR *pSmRes, UINT msg, WPARAM wp);

	typedef struct _replywindowdata
	{
		bool		bRunMsgLoop;
		std::string	str;
	} ReplyWindowData;

public:
	STDMETHOD(ToggleEq)(void);
	STDMETHOD(TogglePlaylist)(void);
	STDMETHOD(VolumeUp)(void);
	STDMETHOD(VolumeDown)(void);
	STDMETHOD(ForwardFiveSeconds)(void);
	STDMETHOD(RewindFiveSeconds)(void);
	STDMETHOD(ButtonPreviousTrack)(void);
	STDMETHOD(ButtonPlay)(void);
	STDMETHOD(ButtonPause)(void);
	STDMETHOD(ButtonStop)(void);
	STDMETHOD(ButtonNextTrack)(void);
	STDMETHOD(ButtonOpenAndPlay)(void);
	STDMETHOD(ButtonFadeOutAndStop)(void);
	STDMETHOD(ButtonPreviousFileInPlaylist)(void);
	STDMETHOD(ButtonOpenLocation)(void);
	STDMETHOD(ButtonNextFileInPlaylist)(void);
	STDMETHOD(ShowOpenFileDialog)(void);
	STDMETHOD(ShowPreferences)(void);
	STDMETHOD(ToggleAlwaysOnTop)(void);
	STDMETHOD(ShowAbout)(void);
	STDMETHOD(ClearPlaylist)(void);
	STDMETHOD(StartPlay)(void);
	STDMETHOD(GetVersion)(LONG* res);
	STDMETHOD(IsPlaying)(LONG* res);
	STDMETHOD(WritePlaylist)(LONG* res);
	STDMETHOD(GetPlaylistLength)(LONG* res);
	STDMETHOD(GetPlaylistPosition)(LONG* res);
	STDMETHOD(GetTrackPositionMilliseconds)(LONG* res);
	STDMETHOD(GetTrackLengthSeconds)(LONG* res);
	STDMETHOD(SetTrackPositionMilliseconds)(LONG arg, LONG* res);
	STDMETHOD(GetTrackSampleRate)(LONG* res);
	STDMETHOD(GetTrackBitRate)(LONG* res);
	STDMETHOD(GetTrackChannels)(LONG* res);
	STDMETHOD(SetPlaylistPosition)(LONG arg);
	STDMETHOD(SetVolume)(LONG arg);
	STDMETHOD(SetPanning)(LONG arg);
	STDMETHOD(GetEqData)(LONG arg, LONG* res);
	STDMETHOD(SetEqData)(LONG arg, LONG val);
	STDMETHOD(PlayFile)(BSTR arg);
	STDMETHOD(ChangeDirectory)(BSTR arg);
	STDMETHOD(GetPlaylistFile)(LONG arg, BSTR* res);
	STDMETHOD(GetPlaylistTitle)(LONG arg, BSTR* res);
};

